#include <time.h>

#include <iostream>
#include "USBDAQException.hh"
#include "LinuxLibUsbInterface.hh"
#include <signal.h>


#include "CaliceMaps1TestSystemInterface.hh"

int gEnd=0;

void CtrlC(int aSigNum){
  std::cout<<"ctrl-c detected, ending program..."<<std::endl;
  gEnd=1;
}

int gQuit=0;
void Usr1(int aSigNum){
  std::cout<<"ctrl-c detected, ending program..."<<std::endl;
  gQuit=1;
}



int main(int argc, char ** argv)
{
  using namespace std;
  using namespace USBDAQ;
  using namespace CALICEMAPS1;
  
  signal(SIGINT, CtrlC);
  //signal(SIGUSR1, Usr1);



  try{
    

    CaliceMaps1TestSystemInterface lInt;

    lInt.EnableLVDSBuffers();
    
    u16 lSel=0;
    if(argc==2){
      istringstream(argv[1])>>lSel;
    }
    
    cout<<"Resetting ";
    if(lSel==0 || lSel==3)	
      cout<<" top ";
    
    if(lSel==1 || lSel==3)
      cout<<" slow ";
    
    if(lSel==2 || lSel==3)
      cout<<" bottom ";
    
    cout<<" shift reg. "<<endl;

    u32 lCount=0;

    do{
      
      if(lSel==0)	
	lInt.IssueTopConfigReset();
      
      if(lSel==1)
	lInt.IssueSlowConfigReset();
      
      if(lSel==2)
	lInt.IssueReadbackConfigReset();
   
      
      if(gEnd==1){
	break;
      }
      
      if((++lCount)%1000==0){
	cout<<lCount<<endl;
      }

      break;
    }while(1);
    
  }catch(USBDAQException & aExc){    
    cerr<<aExc<<endl;
    return 1;
  }catch(std::exception & aExc){
    cerr<<"std::exception & caught: "<<endl;
    cerr<<aExc.what();
    return 2;
  }catch(...){
    cerr<<"Unknown exception caught."<<endl;
    return 3;
  }

  return 0;
}
